# What parts do we want to build?  We must build at least one kernel.
# These are the kernels that are built IF the architecture allows and
# no contrary --with/--without arguments are given on the command line.
#
%define buildup		1
%define buildsmp	1
%define buildBOOT	1
%define buildbigmem	1

# Polite request for people who spin their own kernel rpms:
# please modify the "release" field in a way that identifies
# that the kernel isn't the stock RHL kernel, for example by
# adding some text to the end of the version number.
#
%define release		32.pp
%define sublevel	26
%define kversion	2.4.%{sublevel}

# /usr/src/%{kslnk} -> /usr/src/linux-%{KVERREL}
#
%define kslnk		linux-2.4

# groups of related archs
#
%define all_x86		i386 i586 i686 athlon

# RPM foo magic
#
%define _missing_doc_files_terminate_build	0
%define _unpackaged_files_terminate_build	0
%define debug_package	%{nil}

# Override generic defaults with per-arch defaults (which can
# themselves be overridden with --with/--without).  These must
# ONLY be "0", never "1"
#
%ifnarch i686
   %define buildbigmem	0
%endif
%ifnarch i686 i586 athlon
   %define buildsmp	0
   %define buildup	1
%endif
%ifnarch i386
   %define buildBOOT	0
%endif

# we can't test values inline, only whether a macro exists
#
%{expand: %%define	buildup_%{buildup} yadda}
%{expand: %%define	buildsmp_%{buildsmp} yadda}
%{expand: %%define	buildBOOT_%{buildBOOT} yadda}
%{expand: %%define	buildbigmem_%{buildbigmem} yadda}

%{expand: %%define	kernel_conflicts ppp <= 2.3.15, pcmcia-cs <= 3.1.20, isdn4k-utils <= 3.0, mount < 2.10r-5, nfs-utils < 0.3.1, cipe < 1.4.5, tux < 2.1.0, kudzu <= 0.92, e2fsprogs < 1.22, initscripts < 5.84, dev < 3.2-7, iptables < 1.2.5-3, bcm5820 < 1.81, nvidia-rh72 <= 1.0, oprofile < 0.4}

%define BOOT_kernel_prereq fileutils, modutils >=  2.4.18
%define kernel_prereq	%{BOOT_kernel_prereq}, initscripts >= 5.83, mkinitrd >= 3.2.6 /usr/bin/patch /bin/grep /bin/mknod
%define initrd_dir	/boot
%define kernel_glob	vmlinu?-%{KVERREL}

%define kernel_features	kernel.lkcd kernel.dazuko kernel.lufs kernel.lmsensors kernel.dm kernel.evms kernel.epoll kernel.ipsec kernel.grsec kernel.ostream kernel.cpuaffinity

Summary:	The Linux kernel (the core of the Linux operating system)
Name:		kernel
Version:	%{kversion}
Release:	%{release}
License:	GPL
Group:		System Environment/Kernel
URL:		http://www.kernel.org/
Packager:	Peter Pramberger <peter.pramberger@member.fsf.org>
ExclusiveOS:	linux
ExclusiveArch:	%{all_x86}

Obsoletes:	kernel-modules
Provides:	module-info, kernel = %{version} kernel.pp %{kernel_features}
Provides:	kernel-drm = 4.1.0, kernel-drm = 4.2.0, kernel-drm = 4.3.0, kernel-drm = 4.2.99.3
Autoreqprov:	no
Prereq:		%{kernel_prereq}
Conflicts:	%{kernel_conflicts}
BuildPreReq:	patch >= 2.5.4, bash >= 2.03, sh-utils, gnupg, tar
BuildPreReq:	bzip2, findutils, dev, gzip, m4
BuildConflicts:	rhbuildsys(DiskFree) < 500Mb
BuildRequires:	gcc >= 2.96-98

%define KVERREL	%{PACKAGE_VERSION}-%{PACKAGE_RELEASE}

BuildRoot:	%{_tmppath}/kernel-%{KVERREL}-root


# Source files
#
Source0:	ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%{kversion}.tar.bz2

Source10:	COPYING.modules
Source11:	module-info
Source14:	kernel-2.4-BuildASM.sh
Source15:	linux-rhconfig.h
Source16:	linux-merge-config.awk
Source17:	linux-merge-modules.awk
Source19:	device.awk

Source20:	kernel-%{kversion}-i386.config
Source22:	kernel-%{kversion}-i386-BOOT.config
Source29:	kernel-%{kversion}-i686.config
Source30:	kernel-%{kversion}-i686-smp.config
Source34:	kernel-%{kversion}-i586.config
Source35:	kernel-%{kversion}-i586-smp.config
Source38:	kernel-%{kversion}-i686-bigmem.config
Source40:	kernel-%{kversion}-athlon.config
Source41:	kernel-%{kversion}-athlon-smp.config
Source50:	installkernel.iSeries
Source51:	installcmdline.iSeries

# http://www.freeswan.ca/code/super-freeswan/
Source99:	pp-super-freeswan-1.99.8.tar.gz


# Patches
#
Patch10:	pp-tmp_include_depends.patch

# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/procps-rt/v2.4/
Patch70:	proc-add-rt-info-rml-2.4.20-pre10-1.patch
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/cpu-affinity/v2.4/
Patch71:	cpu-affinity-syscall-rml-2.4.20-1.patch
Patch80:	pp-sem-tuning.patch
# http://www.ssi.bg/~ja/
Patch81:	hidden-forward_shared-noarp-2.4.26-3.diff
# http://www.xmailserver.org/linux-patches/nio-improve.html
Patch82:	epoll-lt-2.4.24-0.20.diff
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/variable-HZ/v2.4/
Patch83:	vhz-j64-2.4.23.patch
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/vm/low-latency-zap_page_range/v2.4/
Patch84:	zap_page_range-rml-2.4.19-pre9-ac3-1.patch

Patch160:	pp-i450nx-doublepciscan-fix.patch

Patch600:	linux-2.4.0-nonintconfig.patch
Patch640:	linux-2.2.16-rhconfig.patch
Patch720:	linux-2.4.9-kksymoops.patch
Patch721:	linux-2.4.9-kallsyms.patch

Patch1000:	linux-2.4.18-nousb.patch
Patch1030:	linux-2.4.0-test11-vidfail.patch
Patch1040:	linux-2.4.0-e820.patch
Patch1080:	linux-2.4.0-apic-quiet.patch
Patch1120:	linux-2.4.2-keyboardsilence.patch
Patch1170:	linux-2.4.7-scsitimeout.patch
Patch1180:	linux-2.4.9-freevxfs.patch
Patch1210:	linux-2.4.18-moreunnamed.patch
Patch1261:	linux-2.4.18-input-35215.patch
Patch1360:	linux-2.4.20-cenatek.patch
Patch1370:	linux-2.4.20-serverworks.patch
Patch1391:	linux-2.4.18-nfs-default-size.patch
Patch1450:	linux-2.4.18-orinoco.patch
Patch1560:	linux-2.4.18-scsidevices.patch
Patch1580:	linux-2.4.18-sillysymlinkfarms.patch
Patch2400:	linux-2.4.18-feral-qlogic-isp.patch
Patch2410:	linux-2.4.9-feral-qlogic-isp-config.patch
Patch2420:	linux-2.4.18-gericom.patch
Patch2450:	linux-2.4.20-pre1-nr_frags.patch
Patch2500:      pp-drm-i386-cmpxchg.patch

Patch4990:	pp-softdog-6min.patch
# http://www.alsa-project.org/alsa/driver-source/utils/patches/
Patch4991:	soundcore.2.4.20.patch
# http://www.alsa-project.org/alsa/driver-source/utils/patches/
Patch4992:	rtc-2.4.25.patch

Patch5000:	linux-2.4.9-addon.patch
Patch5010:	linux-2.4.18-megarac.patch
Patch5030:	linux-2.4.18-wvlan-cs.patch
Patch5050:	linux-2.4.18-ecc.patch
Patch5090:	linux-2.4.6-bcm5820.patch
Patch5091:	linux-2.4.6-bcm5820-2.patch
Patch5092:	linux-2.4.7-bcm5820-16.patch
Patch5093:	linux-2.4.7-bcm5820-17.patch
Patch5094:	linux-2.4.18-bcm5820-update.patch
Patch5120:	linux-2.4.18-iscsi.patch
Patch5180:	linux-2.4.7-tulip.patch
Patch5190:	linux-2.4.0-cipe-1.4.5.patch
Patch5191:	linux-2.4.2-cipe.patch
Patch5192:	linux-2.4.9-cipenat.patch
Patch5193:	linux-2.4.18-cipe-moreinterfaces.patch
# http://download.qlogic.com/drivers/14511/
Patch5210:	pp-qla2x00-v6.06.10-dist.patch.gz
Patch5220:	linux-2.4.9-aep.patch
Patch5270:	linux-2.4.18-audigy.patch
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/O_STREAMING/v2.4/
Patch5701:	O_STREAMING-rml-2.4.20-pre9-1.patch
# ftp://sources.redhat.com/pub/dm/
Patch5702:	pp-device-mapper-1.00.17.patch
# http://downloads.sourceforge.net/sourceforge/evms/
Patch5703:	pp-evms-2.3.2.patch
# http://www.iptables.org/files/
Patch5704:	pp-patch-o-matic-ng-20040302.patch
# http://www.znyx.com/support/drivers/
Patch5705:	pp-znyx-zx370-2.3.23.patch.gz
# http://www.freeswan.ca/code/super-freeswan/
Patch5706:	pp-super-freeswan-1.99.8.patch
Patch5707:	pp-wccp-v2.patch
# http://www.dazuko.org/files/
Patch5708:	pp-dazuko-2.0.1.patch
# http://www.broadcom.com/drivers/downloaddrivers.php
Patch5709:      bcm5700-7.1.22-2.4.24.patch
Patch5710:      pp-bcm4400-3.0.7.patch
# http://downloads.sourceforge.net/sourceforge/lufs/
Patch5711:	lufs-0.9.7-2.4.22.patch.gz
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/netdev-random/v2.4/
Patch5712:	netdev-random-core-rml-2.4.26-pre5.patch
Patch5713:	netdev-random-drivers-rml-2.4.26-pre5.patch
# http://khali.linux-fr.org/devel/i2c/linux-2.4.25/
Patch5714:	linux-2.4.26-i2c-2.8.4.patch
# http://www2.lm-sensors.nu/~lm78/archive/
Patch5715:	pp-lm_sensors-2.8.6.patch.gz

Patch10030:	linux-2.4.18-missing-license-tags.patch

# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/preempt-kernel/v2.4/
Patch19000:	preempt-kernel-rml-2.4.26-pre5-1.patch
# ftp://ftp.kernel.org/pub/linux/kernel/people/rml/lock-break/v2.4/
Patch19001:	lock-break-rml-2.4.18-1.patch

# http://lkcd.sourceforge.net/download/OLD/4.1.1/patches/
Patch19100:	lkcd-2.4.20.diff
Patch19101:     pp-lkcd-watchdog-20040706.patch

# http://www.grsecurity.net/
Patch19200:	grsecurity-2.0-2.4.26.patch
Patch19201:     grsecurity2-vhz-j64.patch

# http://tomt.net/kernel/clear_fpu/2.4/
Patch20001:     00_kernel_ia32-and-x86_64-fix-fpu-state.patch


%package source
Summary:	The source code for the Linux kernel.
Group:		Development/System
Prereq:		fileutils
Requires:	gawk gcc >= 2.96-98

%package doc
Summary:	Various documentation bits found in the kernel source.
Group:		Documentation


%description 
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build custom/third party device
drivers. The source files can also be used to build a custom kernel that is
better tuned to your particular hardware, if you are so inclined (and you
know what you're doing).

%description doc
This package contains documentation files form the kernel
source. Various bits of information about the Linux kernel and the
device drivers shipped with it are documented in these files. 

You'll want to install this package if you need a reference to the
options that can be passed to Linux kernel modules at load time.


%package smp
Summary:	The Linux kernel compiled for SMP machines.
Group:		System Environment/Kernel
Provides:	module-info, kernel = %{version} kernel.pp %{kernel_features}
%ifarch %{all_x86} ia64 x86_64
Provides:	kernel-drm = 4.1.0, kernel-drm = 4.2.0, kernel-drm = 4.3.0, kernel-drm = 4.2.99.3
%endif
Prereq:		%{kernel_prereq}
Conflicts:	%{kernel_conflicts}

%description smp
This package includes a SMP version of the Linux kernel. It is
required only on machines with two or more CPUs, although it should
work fine on single-CPU boxes.

Install the kernel-smp package if your machine uses two or more CPUs.


%package bigmem
Summary:	The Linux Kernel for machines with more than 4 Gigabyte of memory.
Group:		System Environment/Kernel
Provides:	module-info, kernel = %{version} kernel.pp %{kernel_features}
%ifarch %{all_x86} ia64 x86_64
Provides:	kernel-drm = 4.1.0, kernel-drm = 4.2.0, kernel-drm = 4.3.0, kernel-drm = 4.2.99.3
%endif
Prereq:		%{kernel_prereq}
Conflicts:	%{kernel_conflicts}
Obsoletes:	kernel-enterprise <= 2.4.10

%description bigmem
This package includes a kernel that has appropriate configuration options
enabled for Pentium III machines with 4 Gigabyte of memory or more.


%package BOOT
Summary:	The version of the Linux kernel used on installation boot disks.
Group:		System Environment/Kernel
Provides:	kernel = %{version} kernel.pp
Prereq:		%{BOOT_kernel_prereq}
Conflicts:	%{kernel_conflicts}

%description BOOT
This package includes a trimmed down version of the Linux kernel.
This kernel is used on the installation boot disks only and should not
be used for an installed system, as many features in this kernel are
turned off because of the size constraints.


%prep
%setup -q -n %{name}-%{version} -c -a 99
cd linux-%{version}

%patch10 -p1

%patch70 -p1
%patch71 -p1
%patch80 -p1
%patch81 -p1
%patch82 -p1
%patch83 -p1
%patch84 -p1

%patch160 -p1

%patch600 -p1
%patch640 -p1
%patch720 -p1
%patch721 -p1

%patch1000 -p1
%patch1030 -p1
%patch1040 -p1
%patch1080 -p1
%patch1120 -p1
%patch1170 -p1
%patch1180 -p1
%patch1210 -p1
%patch1261 -p1
%patch1360 -p1
%patch1370 -p1
%patch1391 -p1
%patch1450 -p1
%patch1560 -p1
%patch1580 -p1
%patch2400 -p1
%patch2410 -p1
%patch2420 -p1
%patch2450 -p1
%patch2500 -p1

%patch4990 -p1
%patch4991 -p1
%patch4992 -p1

%patch5000 -p1
%patch5010 -p1
%patch5030 -p1
%patch5050 -p1
%patch5090 -p1
%patch5091 -p1
%patch5092 -p1
%patch5093 -p1
%patch5094 -p1
%patch5120 -p1
%patch5180 -p1
%patch5190 -p1
%patch5191 -p1
%patch5192 -p1
%patch5193 -p1
%patch5210 -p1
%patch5220 -p1
%patch5270 -p1
%patch5701 -p1
%patch5702 -p1
%patch5703 -p1
%patch5704 -p1
%patch5705 -p1
%patch5706 -p1
%patch5707 -p4
%patch5708 -p1
%patch5709 -p1
%patch5710 -p1
%patch5711 -p1
%patch5712 -p1
%patch5713 -p1
%patch5714 -p1
%patch5715 -p1

%patch10030 -p1

%patch19000 -p1
%patch19001 -p1

%patch19100 -p1
%patch19101 -p1

%patch19200 -p1
%patch19201 -p0

%patch20001 -p1

cp %{SOURCE10} Documentation/

mkdir configs
cp -fv $RPM_SOURCE_DIR/kernel-%{kversion}-i?86*.config configs
cp -fv $RPM_SOURCE_DIR/kernel-%{kversion}-athlon*.config configs

# make sure the kernel has the sublevel we know it has...
#
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %{sublevel}/" Makefile

# get rid of unwanted files
#
find . -name "*.orig" -exec rm -fv {} \;
find . -name "*~" -exec rm -fv {} \;

chmod 755 arch/*/kernel/check_asm.sh


%build
cd linux-%{version}

DependKernel() {
   # is this a special kernel we want to build?
   if [ -n "$2" ] ; then
      Config=$1-$2
      KernelVer=%{version}-%{release}$2
      echo MAKE DEPEND FOR $2 $1 KERNEL...
   else
      Config=$1
      KernelVer=%{version}-%{release}
      echo MAKE DEPEND FOR up $1 KERNEL...
   fi
   make mrproper
   cp configs/kernel-%{kversion}-$Config.config .config
   # make sure EXTRAVERSION says what we want it to say
   perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$2/" Makefile

   # We do it twice, because make oldconfig tends to get stuff wrong.
   make oldconfig_nonint
   make oldconfig_nonint
   make dep
   make clean
}

BuildKernel() {
   if [ -n "$1" ] ; then
      Config=%{_target_cpu}-$1
      KernelVer=%{version}-%{release}$1
      DependKernel %{_target_cpu} $1
      echo BUILDING A KERNEL FOR $1 %{_target_cpu}...
   else
      Config=%{_target_cpu}
      KernelVer=%{version}-%{release}
      DependKernel %{_target_cpu}
      echo BUILDING THE NORMAL KERNEL for %{_target_cpu}...
   fi

   make CFLAGS_KERNEL="-Wno-unused" bzImage 
   make CFLAGS_KERNEL="-Wno-unused" modules || exit 1
    
   # Start installing stuff
   mkdir -p $RPM_BUILD_ROOT/boot
   install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
   [ -e Kerntypes ] && install -m 644 Kerntypes $RPM_BUILD_ROOT/boot/Kerntypes-$KernelVer
   install -m 644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-$KernelVer
   install -m 644 configs/kernel-%{kversion}-$Config.config $RPM_BUILD_ROOT/boot/config-$KernelVer
   mkdir -p $RPM_BUILD_ROOT/dev/shm

   cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
   cp vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer

   mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer
   make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer

   chmod a-x $RPM_BUILD_ROOT/boot/vmlinux*

   # remove files that will be generated by depmod at rpm -i time
   rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.*
}


rm -rf $RPM_BUILD_ROOT

%if %{buildbigmem}
   BuildKernel bigmem
%endif
%if %{buildsmp}
   BuildKernel smp
%endif
%if %{buildBOOT}
   BuildKernel BOOT
%endif
%if %{buildup}
   BuildKernel
%endif


%define __os_install_post /usr/lib/rpm/brp-compress


%install
cd linux-%{version}
mkdir -p $RPM_BUILD_ROOT/boot

for i in $RPM_BUILD_ROOT/lib/modules/*; do
   rm -f $i/build 
   ln -sf ../../../usr/src/linux-%{KVERREL} $i/build
done

%ifarch athlon i586 i686
   # these don't need much
   exit 0
%endif

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}
rm -f drivers/net/hamradio/soundmodem/gentbl scripts/mkdep
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}/Makefile
ln -sf linux-%{KVERREL} $RPM_BUILD_ROOT/usr/src/linux
install -m 644 %{SOURCE10}  $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}

# clean up the destination
make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}
install -m 644 %{SOURCE15} $RPM_BUILD_ROOT/usr/src/linux-%{KVERREL}/include/linux/rhconfig.h

rm -f $RPM_BUILD_ROOT/usr/include/linux

for i in $RPM_BUILD_ROOT/lib/modules/*; do
   rm -f $i/modules.*
done


%clean
rm -rf $RPM_BUILD_ROOT


%pre 
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre smp
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0

%pre bigmem
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
exit 0


%post 
cd /boot
ln -sf vmlinuz-%{KVERREL} vmlinuz
ln -sf System.map-%{KVERREL} System.map
[ -e Kerntypes-%{KVERREL} ] && ln -sf Kerntypes-%{KVERREL} Kerntypes
ln -sf module-info-%{KVERREL} module-info
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}
fi
[ -c /dev/epoll ] || /bin/mknod /dev/epoll c 10 124

%post smp
cd /boot
ln -sf vmlinuz-%{KVERREL}smp vmlinuz
ln -sf System.map-%{KVERREL}smp System.map
[ -e Kerntypes-%{KVERREL}smp ] && ln -sf Kerntypes-%{KVERREL}smp Kerntypes
ln -sf module-info-%{KVERREL}smp module-info
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}smp
fi
[ -c /dev/epoll ] || /bin/mknod /dev/epoll c 10 124

%post bigmem
cd /boot
ln -sf vmlinuz-%{KVERREL}bigmem vmlinuz
ln -sf System.map-%{KVERREL}bigmem System.map
[ -e Kerntypes-%{KVERREL}bigmem ] && ln -sf Kerntypes-%{KVERREL}bigmem Kerntypes
ln -sf module-info-%{KVERREL}bigmem module-info
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}bigmem
fi
[ -c /dev/epoll ] || /bin/mknod /dev/epoll c 10 124

%post BOOT
cd /boot
ln -sf vmlinuz-%{KVERREL}BOOT vmlinuz
ln -sf System.map-%{KVERREL}BOOT System.map
ln -sf module-info-%{KVERREL}BOOT module-info
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --mkinitrd --depmod --install %{KVERREL}BOOT
fi


%preun 
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
rm -f /lib/modules/%{KVERREL}/modules.*
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}
fi

%preun smp
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
rm -f /lib/modules/%{KVERREL}smp/modules.*
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}smp
fi

%preun bigmem
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
rm -f /lib/modules/%{KVERREL}bigmem/modules.*
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}bigmem
fi

%preun BOOT
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
rm -f /lib/modules/%{KVERREL}BOOT/modules.*
if [ -x /sbin/new-kernel-pkg ] ; then
   /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove %{KVERREL}BOOT
fi


%triggerin -- kudzu
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade || :

%triggerin smp -- kudzu
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade || :

%triggerin bigmem -- kudzu
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade || :

%triggerin BOOT -- kudzu
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade || :

# Patch /sbin/installkernel after change to support LKCD Kerntypes
%triggerin -- mkinitrd
if ! grep Kerntypes /sbin/installkernel >/dev/null 2>&1; then
	/usr/bin/patch -p0 <<EOF
--- /sbin/installkernel.orig	Thu Aug 14 12:23:24 2003
+++ /sbin/installkernel	Thu Aug 14 12:25:19 2003
@@ -9,6 +9,7 @@
 KERNEL_VERSION=\$1
 BOOTIMAGE=\$2
 MAPFILE=\$3
+KERNTYPES=\$4
 
 if [ -f \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION ]; then 
       mv \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION \\
@@ -26,6 +27,15 @@
 ln -fs vmlinuz-\$KERNEL_VERSION \$INSTALL_PATH/vmlinuz
 ln -fs System.map-\$KERNEL_VERSION \$INSTALL_PATH/System.map
 
+if [ \$KERNTYPES ]; then
+	if [ -f \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION ]; then 
+		mv \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION \\
+			\$INSTALL_PATH/Kerntypes.old; 
+	fi
+	cp \$KERNTYPES \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION
+	ln -fs Kerntypes-\$KERNEL_VERSION \$INSTALL_PATH/Kerntypes
+fi
+
 if [ -x /sbin/new-kernel-pkg ]; then
 	/sbin/new-kernel-pkg --mkinitrd --depmod --install \$KERNEL_VERSION
 fi
EOF
fi

%triggerin smp -- mkinitrd
if ! grep Kerntypes /sbin/installkernel >/dev/null 2>&1; then
	/usr/bin/patch -p0 <<EOF
--- /sbin/installkernel.orig	Thu Aug 14 12:23:24 2003
+++ /sbin/installkernel	Thu Aug 14 12:25:19 2003
@@ -9,6 +9,7 @@
 KERNEL_VERSION=\$1
 BOOTIMAGE=\$2
 MAPFILE=\$3
+KERNTYPES=\$4
 
 if [ -f \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION ]; then 
       mv \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION \\
@@ -26,6 +27,15 @@
 ln -fs vmlinuz-\$KERNEL_VERSION \$INSTALL_PATH/vmlinuz
 ln -fs System.map-\$KERNEL_VERSION \$INSTALL_PATH/System.map
 
+if [ \$KERNTYPES ]; then
+	if [ -f \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION ]; then 
+		mv \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION \\
+			\$INSTALL_PATH/Kerntypes.old; 
+	fi
+	cp \$KERNTYPES \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION
+	ln -fs Kerntypes-\$KERNEL_VERSION \$INSTALL_PATH/Kerntypes
+fi
+
 if [ -x /sbin/new-kernel-pkg ]; then
 	/sbin/new-kernel-pkg --mkinitrd --depmod --install \$KERNEL_VERSION
 fi
EOF
fi

%triggerin bigmem -- mkinitrd
if ! grep Kerntypes /sbin/installkernel >/dev/null 2>&1; then
	/usr/bin/patch -p0 <<EOF
--- /sbin/installkernel.orig	Thu Aug 14 12:23:24 2003
+++ /sbin/installkernel	Thu Aug 14 12:25:19 2003
@@ -9,6 +9,7 @@
 KERNEL_VERSION=\$1
 BOOTIMAGE=\$2
 MAPFILE=\$3
+KERNTYPES=\$4
 
 if [ -f \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION ]; then 
       mv \$INSTALL_PATH/vmlinuz-\$KERNEL_VERSION \\
@@ -26,6 +27,15 @@
 ln -fs vmlinuz-\$KERNEL_VERSION \$INSTALL_PATH/vmlinuz
 ln -fs System.map-\$KERNEL_VERSION \$INSTALL_PATH/System.map
 
+if [ \$KERNTYPES ]; then
+	if [ -f \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION ]; then 
+		mv \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION \\
+			\$INSTALL_PATH/Kerntypes.old; 
+	fi
+	cp \$KERNTYPES \$INSTALL_PATH/Kerntypes-\$KERNEL_VERSION
+	ln -fs Kerntypes-\$KERNEL_VERSION \$INSTALL_PATH/Kerntypes
+fi
+
 if [ -x /sbin/new-kernel-pkg ]; then
 	/sbin/new-kernel-pkg --mkinitrd --depmod --install \$KERNEL_VERSION
 fi
EOF
fi


%triggerpostun source -- kernel-headers < 2.2.16
cd /usr/src
rm -f %{kslnk}
ln -snf linux-%{KVERREL} %{kslnk}
exit 0


%post source
cd /usr/src
rm -f %{kslnk}
ln -snf linux-%{KVERREL} %{kslnk}

%postun source
if [ -L /usr/src/%{kslnk} ]; then 
   if [ -L /usr/src/%{kslnk} -a `ls -ld /usr/src/%{kslnk} 2>/dev/null| awk '{ print $11 }'` = "linux-%{KVERREL}" ]; then
      [ $1 = 0 ] && rm -f /usr/src/%{kslnk}
   fi
fi
exit 0


%if %{buildup}
%files 
%defattr(-,root,root)
/boot/%{kernel_glob}
/boot/module-info-%{KVERREL}
/boot/System.map-%{KVERREL}
/boot/Kerntypes-%{KVERREL}
/boot/config-%{KVERREL}
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}
%endif

%if %{buildsmp}
%ifnarch i386
%files smp
%defattr(-,root,root)
/boot/%{kernel_glob}smp
/boot/module-info-%{KVERREL}smp
/boot/System.map-%{KVERREL}smp
/boot/Kerntypes-%{KVERREL}smp
/boot/config-%{KVERREL}smp
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}smp
%endif
%endif

%if %{buildbigmem}
%ifarch i686
%files bigmem
%defattr(-,root,root)
/boot/%{kernel_glob}bigmem
/boot/module-info-%{KVERREL}bigmem
/boot/System.map-%{KVERREL}bigmem
/boot/Kerntypes-%{KVERREL}bigmem
/boot/config-%{KVERREL}bigmem
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}bigmem
%endif
%endif

%if %{buildBOOT}
%ifarch i386
%files BOOT
%defattr(-,root,root)
/boot/%{kernel_glob}BOOT
/boot/System.map-%{KVERREL}BOOT
/boot/config-%{KVERREL}BOOT
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}BOOT
%endif
%endif

%ifarch i386
%files source
%defattr(-,root,root)
%dir /usr/src/linux-%{KVERREL}
/usr/src/linux-%{KVERREL}/*

%files doc
%defattr(-,root,root)
%doc linux-%{version}/Documentation/*
%endif


%changelog
* Tue Jul 06 2004 peter.pramberger@member.fsf.org
- added FPU security fix
- allow GRSecurity proc user group
- added LKCD watchdog patch

* Wed May 05 2004 peter.pramberger@member.fsf.org
- kernel 2.4.26-pp released

* Thu Apr 29 2004 peter.pramberger@member.fsf.org
- updated:
-    GRSecurity 2.0
-    EVMS 2.3.2

* Wed Apr 28 2004 peter.pramberger@member.fsf.org
- minor specfile modifications

* Tue Apr 27 2004 peter.pramberger@member.fsf.org
- updated:
-    Preempt-kernel and lock-break patches
-    LKCD 4.1.1

* Mon Apr 26 2004 peter.pramberger@member.fsf.org
- added:
-    Broadcom BCM5700 driver
-    Broadcom BCM4400 driver
- updated:
-    Dazuko 2.0.1
-    Linux Userland Filesystem 0.9.7
-    Entropy gathering via net devices
-    I2C driver subsystem 2.8.4
-    LM_Sensors 2.8.6

* Sun Apr 25 2004 peter.pramberger@member.fsf.org
- updated:
-    QLogic QLA2x00 FC Adapter driver 6.06.10
-    Device Mapper 1.00.17
-    EVMS 2.3.1
-    Iptables patch-o-matic-ng 20040302
-    Znyx ZX370 series network driver 2.3.23

* Fri Apr 23 2004 peter.pramberger@member.fsf.org
- working on kernel 2.4.26
- updated:
-    Hidden-Forward_Shared-NoARP
-    EPOLL 0.20
-    Variable HZ/J64
-    Alsa 0.9.6 RTC + Soundcore patch

* Fri Sep 19 2003 peter.pramberger@member.fsf.org
- kernel 2.4.22-pp released

* Sun Sep 14 2003 peter.pramberger@member.fsf.org
- added:
-    Patch 2.4.23-pre4
-    GRSecurity 1.9.12
-    Alsa 0.9.6 RTC + Soundcore patch

* Mon Sep 08 2003 peter.pramberger@member.fsf.org
- added:
-    LKCD 2.4.2-pre4

* Sun Sep 07 2003 peter.pramberger@member.fsf.org
- added:
-    Preempt-kernel and lock-break patches
-    Dazuko 1.2.2-pre3

* Fri Aug 29 2003 peter.pramberger@member.fsf.org
- added:
-    Entropy gathering via net devices

* Wed Aug 27 2003 peter.pramberger@member.fsf.org
- working on kernel 2.4.22
- added:
-    Patch 2.4.23-pre3
-    Super FreeSWAN 1.99.8
-    Proc Realtime Info
-    CPU affinity
-    Semaphore Tuning
-    Hidden-Forward_Shared-NoARP
-    EPOLL 0.18
-    Configurable HZ
-    i450NX Double Primary PCI-Bus Scan Fix
-    Znyx ZX370 series network driver 2.3.17
-    Software Watchdog 6min Timeout
-    QLogic QLA2x00 FC Adapter driver 6.04.00
-    WCCPv2 redirect module 1.1
-    Linux Userland Filesystem 0.9.6
-    Some of Iptables patch-o-matic 20030107
-    Device Mapper 1.00.05
-    EVMS 2.1.1
-    O_STREAMING support
-    zap_page_range optimization
- removed:
-    Non IA32 platforms from spec file

* Wed Aug 20 2003 peter.pramberger@member.fsf.org
- kernel 2.4.20-pp released

* Wed Aug 13 2003 peter.pramberger@member.fsf.org
- added:
-    LKCD 4.1.1
-    Undo RedHats sys_call_table removal

* Wed Aug 06 2003 peter.pramberger@member.fsf.org
- added:
-    GRSecurity 1.9.11

* Mon Jul 28 2003 peter.pramberger@member.fsf.org
- added:
-    O_STREAMING support
-    zap_page_range optimization
-    Entropy gathering via net devices
-    Preempt-kernel and lock-break patches

* Tue Jul 22 2003 peter.pramberger@member.fsf.org
- working on kernel 2.4.21
- added:
-    Super FreeSWAN 1.99.8
-    Proc Realtime Info
-    CPU affinity
-    Semaphore Tuning
-    Hidden-Forward_Shared-NoARP
-    EPOLL 0.16
-    Configurable HZ
-    i450NX Double Primary PCI-Bus Scan Fix
-    Znyx ZX370 series network driver 2.3.17
-    Software Watchdog 6min Timeout
-    QLogic QLA2x00 FC Adapter driver 6.04.00
-    WCCPv2 redirect module 1.1
-    Dazuko 1.2.2-pre2
-    Linux Userland Filesystem 0.9.6
-    Some of Iptables patch-o-matic 20030107
-    Device Mapper 1.0.10
-    EVMS 2.1.0

